<?php 
$current_view = "event";
define('BASE', '../');
include_once(BASE.'functions/init.inc.php'); 
require_once(BASE.'functions/date_functions.php');
require_once(BASE.'functions/template.php');
require_once(BASE.'functions/timezones.php');

# information for the popup is sent via $_POST by a javascript snippet in 
# in function openevent() from functions/date_functions.php
# character encoding has been problematic with popups.
$uid = stripslashes($_POST['uid']);
if (isset($_POST['submit'])){
	$uid = $_POST['uid'];
	header("Content-Type: text/calendar; charset=utf-8; name=$uid");
	header("Content-Disposition: attachment; filename=$uid");
	echo(getfile($_POST["calpath"], $uid));
	exit;
}
$event			= unserialize(stripslashes($_POST['event_data']));
$calurl			= getCalendarPath(availableCalendars($username, $password, $phpiCal_config->ALL_CALENDARS_COMBINED), $event['calname']);
$organizers		= unserialize($event['organizer']);
$attendees 		= unserialize($event['attendee']);

$cals = availableCalendars($username, $password, $phpiCal_config->ALL_CALENDARS_COMBINED);
$calnames = unserialize(stripslashes($_POST['calnames']));
$selectcals = "<select name=\"calurl\" id=\"calurl\">";
for ($c=0;$c<count($cals);$c++){
	if ($cals[$c] == $calurl) $seled = "selected=\"selected\""; else $seled = "";
	$selectcals .= "<option value=\"".$cals[$c]."\" $seled>".$calnames[$cals[$c]]."</option>";
}
$selectcals .= "</select>";


// Format event time
// All day
if ($_POST['time'] == -1) {
	$start = localizeDate($dateFormat_week, $event['start_unixtime']);
	$end   = localizeDate($dateFormat_week, ($event['end_unixtime'] - 60));
	$event_times = $lang['l_all_day']." $start";
	if ($start != $end) $event_times = "$start - $end";
	$alldayjs = '<script language="javascript" type="text/javascript">document.getElementById(\'allday\').checked = true; runAllDayTick(); </script>';
} else {
	$start = date($timeFormat, $event['start_unixtime']);
	$end   = date($timeFormat, $event['end_unixtime']);
	$event_times = "$start";
	if ($start != $end) $event_times = "$start - $end";
	$alldayjs = '';
}

$event['event_text']  = urldecode($event['event_text']);
$event['description'] = urldecode($event['description']);
$event['location']    = urldecode($event['location']);
$display ='';
if (isset($event['description'])) $event['description'] = ereg_replace("[[:alpha:]]+://[^<>[:space:]]+[[:alnum:]/]",'<a target="_new" href="\0">\0</a>',$event['description']);

$organizerhtml = "";
foreach ($organizers as $organizer) {
	$organizerhtml .= "<a href=\"mailto:".$organizer['email']."?subject=".$event['event_text']."\">".$organizer['name']."</a><br />";
}
$attendeehtml = "";
foreach ($attendees as $attendee) {
	if (array_key_exists('PARSTAT', $attendee)) {
		if ($attendee['PARSTAT'] == 'NEEDS-ACTION') {
			$attendeehtml .= "<img src=\"../images/attendeetentative.png\" /> ";
		}
		if ($attendee['PARSTAT'] == 'ACCEPTED') {
			$attendeehtml .= "<img src=\"../images/attendeeconfirmed.png\" /> ";
		}
		if ($attendee['PARSTAT'] == 'DECLINED') {
			$attendeehtml .= "<img src=\"../images/attendeecancelled.png\" /> ";
		}
	}
	$attendeehtml .= "<a href=\"mailto:".$attendee['email']."?subject=".$event['event_text']."\">".$attendee['name']."</a><br />";
}
if (count($attendees) + count($attendees) > 1) {
	$attenteeextrahtml = "<br /><a href=\"mailto:";	
	foreach ($organizers as $organizer) {
		$attenteeextrahtml .= $organizer['email'].",";
	}
	foreach ($attendees as $attendee) {
		$attenteeextrahtml .= $attendee['email'].",";
	}
	$attenteeextrahtml = substr($attenteeextrahtml, 0 , -1);
	$attenteeextrahtml .= "?subject=".$event['event_text']."\" style=\"font-weight: normal;\">Email All</a>";
} else {
	$attenteeextrahtml = "";
}

if (isset($event['location'])) $event['location'] = stripslashes($event['location']);
if ($event['url'] != '') $event['url'] = '<a href="'.$event['url'].'" target="_blank">'.$event['url'].'</a>';

$event_download = '';
if($phpiCal_config->event_download == 'yes') $event_download = "
<form action='' method='post'>
<input type='hidden' name='calpath' value = '".$calurl."' />
<input type='hidden' name='uid' value = '".$_POST['uid']."' />
<input type='submit' name='submit' value='".$lang['l_download_event']."' />
<form>";

$recurring = prepreoccuring($event);

$selectedtxt = "selected=\"selected\"";
$selected = "";
$statusselect = "<select name=\"meetingstatus\" id=\"meetingstatus\">\n";
$selected = ""; if (!isset($event['status'])) $selected = $selectedtxt;
$statusselect .= "	<option $selected value=\"\"></option>\n";
$selected = ""; if ($event['status'] == "TENTATIVE") $selected = $selectedtxt;
$statusselect .= "	<option $selected value=\"TENTATIVE\">".$lang['l_status_tentative']."</option>\n";
$selected = ""; if ($event['status'] == "CONFIRMED") $selected = $selectedtxt;
$statusselect .= "	<option $selected value=\"CONFIRMED\">".$lang['l_status_confirmed']."</option>\n";
$selected = ""; if ($event['status'] == "CANCELLED") $selected = $selectedtxt;
$statusselect .= "	<option $selected value=\"CANCELLED\">".$lang['l_status_cancelled']."</option>\n";
$statusselect .= "</select>\n";

$selected = "";
$transselect = "<select name=\"busystatus\" id=\"busystatus\">\n";
$selected = ""; if (array_key_exists('transp', $event) && $event['transp'] == "OPAQUE") $selected = $selectedtxt;
$transselect .= "	<option $selected value=\"OPAQUE\">Opaque</option>\n";
$selected = ""; if (array_key_exists('transp', $event) && $event['transp'] == "TRANSPARENT") $selected = $selectedtxt;
$transselect .= "	<option $selected value=\"TRANSPARENT\">Transparent</option>\n";
$transselect .= "</select>\n";

$tzselect = " <select name=\"timezone\" id=\"timezone\">\n";
foreach ($tz_array as $k => $e) {
	$selected = "";
	if (strpos(trim($event['timezone']), substr($k, strpos($k, "/"))) !== false) {
		$selected = $selectedtxt;
	}
	if ($event['timezone'] == "" && $k == "Europe/London") {
		$selected = $selectedtxt;
	}
	$tzselect .= "<option $selected>$k</option>\n";
}
$tzselect .= "</select>\n";

$page = new Page(BASE.'templates/'.$phpiCal_config->template.'/event.tpl');

$page->replace_tags(array(
	'charset'			=> $phpiCal_config->charset,
	'cal' 				=> $_POST['cpath'],
	'event_text' 		=> $event['event_text'],
	'event_times' 		=> $event_times,
	'event_start_d'		=> date("Y/m/d",$event['start_unixtime']),
	'event_start_t'		=> date("H:i",$event['start_unixtime']),
	'event_end_d' 		=> date("Y/m/d",$event['end_unixtime']),
	'event_end_t' 		=> date("H:i",$event['end_unixtime']),
	'event_uid'			=> $uid,
	'event_timezone'	=> $tzselect,
	'description' 		=> str_replace('<br />',"\n",$event['description']),
	//'description' 		=> print_r($event, true),
	'categories'		=> $event['categories'],
	'organizer' 		=> $organizerhtml,
	'attendee'	 		=> $attendeehtml,
	'status'	 		=> $statusselect,
	'location' 			=> $event['location'],
	'busystatus' 		=> $transselect,
	'recurring_event'	=> $recurring,
	'event_download'	=> $event_download,
	'calendar'     		=> $selectcals,
	'cal_title_full'	=> $event['calname'].' '.$lang['l_calendar'],
	'template'			=> $phpiCal_config->template,
	'l_calendar' 		=> $lang['l_calendar'],
	'l_summary' 		=> $lang['l_summary'],
	'l_description'		=> $lang['l_description'],
	'l_organizer'		=> $lang['l_organizer'],
	'l_attendee'		=> $lang['l_attendee'].$attenteeextrahtml,
	'l_status'			=> $lang['l_status'],
	'l_location'		=> $lang['l_location'],
	'l_url'     		=> $lang['l_url'],
	'l_event_start'		=> $lang['l_event_start'],
	'l_event_end' 		=> $lang['l_event_end'],
	'l_all_day'			=> $lang['l_all_day'],
	'l_recurring_event' => $lang['l_recurring_event'],
	'l_categories'		=> "Categories",
	'l_busystatus' 		=> "Transp",
	'all_day_js'		=> $alldayjs
		
	));

$page->output();


function prepreoccuring($event) {
	$freq = "";
	if (is_array($event['recur'])) {
		$freq = strtolower($event['recur']['FREQ']);
	}
	
	$selectedtxt = "selected=\"selected\"";
	$recurring = "<select name=\"recurringtype\" id=\"recurringtype\" onChange=\"hideshowrecurring(this.value);\">\n";
	if ($freq == "") { $seled = $selectedtxt; } else { $seled = ""; }
	$recurring .= "	<option $seled value=\"0\">Does not repeat</option>\n";
	if ($freq == "daily") { $seled = $selectedtxt; } else { $seled = ""; }
	$recurring .= "	<option $seled value=\"1\">Daily</option>\n";
	if ($freq == "weekly") { $seled = $selectedtxt; } else { $seled = ""; }
	$recurring .= "	<option $seled value=\"2\">Weekly</option>\n";
	if ($freq == "monthly") { $seled = $selectedtxt; } else { $seled = ""; }
	$recurring .= "	<option $seled value=\"5\">Monthly</option>\n";
	if ($freq == "yearly") { $seled = $selectedtxt; } else { $seled = ""; }
	$recurring .= "	<option $seled value=\"6\">Yearly</option>\n";
	$recurring .= "</select>\n";
	$recurring .= "</td></tr>";
	
	if ($freq == "daily") {
		$seled=$event['recur']['INTERVAL'];
		$disp = "";
	} else {
		$seled="";
		$disp = "none";	
	}
	$recurring .= "<tr id=\"Daily\" style=\"display:$disp;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"dailyinterval\" id=\"dailyinterval\" value=\"$seled\" size=\"3\" /> days";
	$recurring .= "</td></tr>";
	
	if ($freq == "weekly") {
		$seled=$event['recur']['INTERVAL'];
		$disp = "";
	} else {
		$seled="";
		$disp = "none";	
	}
	$recurring .= "<tr id=\"Weekly\" style=\"display:$disp;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"weeklyinterval\" id=\"weeklyinterval\" value=\"$seled\" size=\"3\" /> weeks<br />";
	if (isset($event['recur']['BYDAY'])) {
		foreach ($event['recur']['BYDAY'] as $day) {
			if ($day == "MO") $monsel = "checked=\"checked\""; else $monsel = "";
			if ($day == "TU") $tuesel = "checked=\"checked\""; else $tuesel = "";
			if ($day == "WE") $wedsel = "checked=\"checked\""; else $wedsel = "";
			if ($day == "TH") $thusel = "checked=\"checked\""; else $thusel = "";
			if ($day == "FR") $frisel = "checked=\"checked\""; else $frisel = "";
			if ($day == "SA") $satsel = "checked=\"checked\""; else $satsel = "";
			if ($day == "SU") $sunsel = "checked=\"checked\""; else $sunsel = "";
		}
	} else {
		$day = date('N', $event['start_unixtime']);
		if ($day == 1) $monsel = "checked=\"checked\""; else $monsel = "";
		if ($day == 2) $tuesel = "checked=\"checked\""; else $tuesel = "";
		if ($day == 3) $wedsel = "checked=\"checked\""; else $wedsel = "";
		if ($day == 4) $thusel = "checked=\"checked\""; else $thusel = "";
		if ($day == 5) $frisel = "checked=\"checked\""; else $frisel = "";
		if ($day == 6) $satsel = "checked=\"checked\""; else $satsel = "";
		if ($day == 7) $sunsel = "checked=\"checked\""; else $sunsel = "";
	}
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysm\" value=\"MO\" $monsel /> Monday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaystu\" value=\"TU\" $tuesel /> Tuesday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysw\" value=\"WE\" $wedsel /> Wednesday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayst\" value=\"TH\" $thusel /> Thursday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysf\" value=\"FR\" $frisel /> Friday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayssa\" value=\"SA\" $satsel /> Saturday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayss\" value=\"SU\" $sunsel /> Sunday ";
	$recurring .= "</td></tr>";
	
	if ($freq == "monthly") {
		$seled=$event['recur']['INTERVAL'];
		$disp = "";
	} else {
		$seled="";
		$disp = "none";	
	}
	$recurring .= "<tr id=\"Monthly\" style=\"display:$disp;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"monthlyinterval\" id=\"monthlyinterval\" value=\"$seled\" size=\"3\" /> months<br/>";
	if (isset($event['recur']['BYDAY']) && $freq == "monthly") {
		$seled1 = substr($event['recur']['BYDAY'][0], 0, 1);
		$seled2 = substr($event['recur']['BYDAY'][0], -2);
		$check = "checked=\"checked\"";
	} else {
		$seled = "";
		$check = "";	
		$seled1 = "";
		$seled2 = "";
	}
	$recurring .= "	<input type=\"radio\" name=\"monthlytype\" value=\"byweek\" $check /> The ";
	$recurring .= "		<select name=\"monthlyweeknum\">";
	if ($seled1 == "1") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"1\">First</option>";
	if ($seled1 == "2") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"2\">Second</option>";
	if ($seled1 == "3") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"3\">Third</option>";
	if ($seled1 == "4") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"4\">Fourth</option>";
	if ($seled1 == "5") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"5\">Fifth</option>";
	if ($seled1 == "-1") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"-1\">Last</option>";
	$recurring .= "		</select>";
	$recurring .= "		<select name=\"monthlydayname\">";
	if ($seled2 == "MO") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"MO\">Monday</option>";
	if ($seled2 == "TU") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"TU\">Tuesday</option>";
	if ($seled2 == "WE") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"WE\">Wednesday</option>";
	if ($seled2 == "TH") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"TH\">Thursday</option>";
	if ($seled2 == "FR") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"FR\">Friday</option>";
	if ($seled2 == "SA") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"SA\">Satruday</option>";
	if ($seled2 == "SU") { $seled = $selectedtxt; } else { $seled = "";}
	$recurring .= "			<option $seled value=\"SU\">Sunday</option>";						
	$recurring .= "		</select>";
	$recurring .= "		<br />";
	if (isset($event['recur']['BYMONTHDAY'])) {
		$seled = $event['recur']['BYMONTHDAY'][0];
		$check = "checked=\"checked\"";
	} else {
		$seled = "";
		$check = "";	
	}
	$recurring .= "		<input type=\"radio\" name=\"monthlytype\" value=\"byday\" $check /> Recur on the <input type=\"text\" name=\"monthlyday\" id=\"monthlyday\" value=\"$seled\" size=\"5\" /> day of the month ";
	$recurring .= "</td></tr>";
	
	if ($freq == "yearly") {
		$seled=$event['recur']['INTERVAL'];
		$disp = "";
	} else {
		$seled="";
		$disp = "none";	
	}
	$recurring .= "<tr id=\"Yearly\" style=\"display:$disp;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"yearlyinterval\" id=\"yearlyinterval\" value=\"$seled\" size=\"3\" /> years";
	$recurring .= "</td></tr>";
	
	if ($freq != "") {
		$disp = "";
	} else {
		$disp = "none";	
	}
	$recurring .= "<tr id=\"recurring\" style=\"display:$disp;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "	<br />";
	$selected="";
	if (is_array($event['recur']) && isset($event['recur']['COUNT'])) {
		$type = 1;
	} else {
		if (is_array($event['recur']) && isset($event['recur']['UNTIL'])) {
			$type = 2;
		} else {
			$type = 3;
		}
	}
	if ($type == 3) {
		$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"none\" checked=\"checked\" />No end date<br />";
	} else {
		$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"none\" />No end date<br />";
	}
	
	if ($type == 1) {
		$selected=$event['recur']['COUNT'];
		$recurring .= "	<input type=\"radio\" name=\"untilcount\" value=\"count\" checked=\"checked\" />";
	} else {
		$selected="";
		$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"count\" />";
	}
	$recurring .= "Create ";
	$recurring .= "<input type=\"text\" name=\"count\" id=\"count\" value=\"$selected\" size=\"3\" /> appointment(s)<br />";
	
	if ($type == 2) {
		$selected=$event['recur']['UNTIL'];
		$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"until\" checked=\"checked\" />";
	} else {
		$selected="";
		$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"until\" />";
	}
	$recurring .= "Repeat until ";
	$recurring .= "<input type=\"text\" name=\"until\" id=\"until\" value=\"$selected\" size=\"10\" />";
	if ($freq != "" && array_key_exists('rec_start_unixtime', $event)) $val = $event['rec_start_unixtime']; else $val="";
	$recurring .= "<input type=\"text\" name=\"recstart\" id=\"recstart\" value=\"".$val."\" />";
	if ($freq != "" && array_key_exists('rec_end_unixtime', $event)) $val = $event['rec_end_unixtime']; else $val="";
	$recurring .= "<input type=\"text\" name=\"recend\" id=\"recend\" value=\"".$val."\" />";
	
	return $recurring;
}

function getfile($calpath, $uid) {
	$filecontents = "";
	if (strpos($calpath, "http://") !== false || strpos($calpath, "https://") !== false) {
		$path = parse_url($calpath);
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $calpath."/".$uid.".ics");
		$user = $path["user"];
		$pass = $path["pass"];
		$userpass = $user.":".$pass;
		if ($userpass == ":") unset($userpass);
		if (isset($userpass)) {
			curl_setopt($ch, CURLOPT_USERPWD, $userpass);
			curl_setopt($ch, CURLOPT_HTTPAUTH, CURLAUTH_ANY);
		}
		if (strpos($calpath, "https://") !== false) {
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
		}			
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		$filecontents = curl_exec($ch);
	} else {
		if (file_exists($calpath)) {
			$handle = fopen($calpath, "r");
			$filecontents = fread($handle, filesize($calpath));
		}
	}
	return $filecontents;
}
?>
