<?php 
$current_view = "newevent";
define('BASE', '../');
include_once(BASE.'functions/init.inc.php'); 
require_once(BASE.'functions/date_functions.php');
require_once(BASE.'functions/template.php');

# information for the popup is sent via $_POST by a javascript snippet in 
# in function openevent() from functions/date_functions.php
# character encoding has been problematic with popups.

$cals = availableCalendars($username, $password, $phpiCal_config->ALL_CALENDARS_COMBINED);
$calnames = unserialize(stripslashes($_POST['calnames']));
$selectcals = "<select name=\"calurl\" id=\"calurl\">";
for ($c=0;$c<count($cals);$c++){
	$selectcals .= "<option value=\"".$cals[$c]."\">".$calnames[$cals[$c]]."</option>";
}
$selectcals .= "</select>";

$date   = date('Ymd\THisT');
$unique = substr(microtime(), 2, 4);
$base   = 'aAbBcCdDeEfFgGhHiIjJkKlLmMnNoOpPrRsStTuUvVxXuUvVwWzZ1234567890';
$start  = 0;
$end    = strlen( $base ) - 1;
$length = 6;
$str    = null;
for( $p = 0; $p < $length; $p++ )
	$unique .= $base{mt_rand( $start, $end )};
$uid = $date.'-'.$unique;

$statusselect = "<select name=\"meetingstatus\" id=\"meetingstatus\">\n";
$statusselect .= "	<option value=\"\"></option>\n";
$statusselect .= "	<option value=\"TENTATIVE\">".$lang['l_status_tentative']."</option>\n";
$statusselect .= "	<option value=\"CONFIRMED\">".$lang['l_status_confirmed']."</option>\n";
$statusselect .= "	<option value=\"CANCELLED\">".$lang['l_status_cancelled']."</option>\n";
$statusselect .= "</select>\n";

$transselect = "<select name=\"busystatus\" id=\"busystatus\">\n";
$transselect .= "	<option value=\"OPAQUE\">Opaque</option>\n";
$transselect .= "	<option value=\"TRANSPARENT\">Transparent</option>\n";
$transselect .= "</select>\n";

// Format event time
// All day
$start = (int)$_POST['startdt'];
$end = mktime(date('h',$start)+1, date('i',$start), date('s',$start), date('m',$start),date('d',$start), date('Y',$start));

$page = new Page(BASE.'templates/'.$phpiCal_config->template.'/newevent.tpl');

$page->replace_tags(array(
	'event_title_full'	=> 'New Event',
	'event_text'		=> '',
	'location'			=> '',
	'event_timezone'	=> '',
	'description'		=> '',
	'organizer'			=> '',
	'status'			=> '',
	'event_uid'			=> $uid,
	'status'	 		=> $statusselect,
	'busystatus' 		=> $transselect,
	'recurring_event'	=> prepreoccuring($start),
	'charset'			=> $phpiCal_config->charset,
	'event_start_d'		=> date("Y/m/d",$start),
	'event_start_t'		=> date("H:i",$start),
	'event_end_d'		=> date("Y/m/d",$end),
	'event_end_t'		=> date("H:i",$end),
	'template'			=> $phpiCal_config->template,
	'calendar'	 		=> $selectcals,
	'l_calendar' 		=> $lang['l_calendar'],
	'l_summary' 		=> $lang['l_summary'],
	'l_description'		=> $lang['l_description'],
	'l_organizer'		=> $lang['l_organizer'],
	'l_attendee'		=> $lang['l_attendee'],
	'l_status'			=> $lang['l_status'],
	'l_status_confirmed'=> $lang['l_status_confirmed'],
	'l_status_cancelled'=> $lang['l_status_cancelled'],
	'l_status_tentative'=> $lang['l_status_tentative'],
	'l_location'		=> $lang['l_location'],
	'l_url'     		=> $lang['l_url'],
	'l_event_start'		=> $lang['l_event_start'],
	'l_event_end' 		=> $lang['l_event_end'],
	'l_all_day'			=> $lang['l_all_day'],
	'l_recurring_event' => $lang['l_recurring_event'],
	'l_categories'		=> "Categories",
	'l_busystatus' 		=> "Transp",
	'all_day_js'		=> ''
	));

$page->output();

function prepreoccuring($start) {
	$selectedtxt = "selected=\"selected\"";
	$recurring = "<select name=\"recurringtype\" id=\"recurringtype\" onChange=\"hideshowrecurring(this.value);\">\n";
	$recurring .= "	<option value=\"0\">Does not repeat</option>\n";
	$recurring .= "	<option value=\"1\">Daily</option>\n";
	$recurring .= "	<option value=\"2\">Weekly</option>\n";
	$recurring .= "	<option value=\"5\">Monthly</option>\n";
	$recurring .= "	<option value=\"6\">Yearly</option>\n";
	$recurring .= "</select>\n";
	$recurring .= "</td></tr>";
	
	$recurring .= "<tr id=\"Daily\" style=\"display:none;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"dailyinterval\" id=\"dailyinterval\" size=\"3\" value=\"1\" /> days";
	$recurring .= "</td></tr>";
	
	$recurring .= "<tr id=\"Weekly\" style=\"display:none;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"weeklyinterval\" id=\"weeklyinterval\" size=\"3\" value=\"1\" /> weeks<br />";
	
	$day = (int) date('N', $start);
	if ($day == 1) {$monsel = "checked=\"checked\""; } else { $monsel = ""; }
	if ($day == 2) {$tuesel = "checked=\"checked\""; } else { $tuesel = ""; }
	if ($day == 3) {$wedsel = "checked=\"checked\""; } else { $wedsel = ""; }
	if ($day == 4) {$thusel = "checked=\"checked\""; } else { $thusel = ""; }
	if ($day == 5) {$frisel = "checked=\"checked\""; } else { $frisel = ""; }
	if ($day == 6) {$satsel = "checked=\"checked\""; } else { $satsel = ""; }
	if ($day == 7) {$sunsel = "checked=\"checked\""; } else { $sunsel = ""; }
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysm\" value=\"MO\" $monsel /> Monday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaystu\" value=\"TU\" $tuesel /> Tuesday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysw\" value=\"WE\" $wedsel /> Wednesday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayst\" value=\"TH\" $thusel /> Thursday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdaysf\" value=\"FR\" $frisel /> Friday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayssa\" value=\"SA\" $satsel /> Saturday ";
	$recurring .= "		<input type=\"checkbox\" name=\"weekdayss\" value=\"SU\" $sunsel /> Sunday ";
	$recurring .= "</td></tr>";
	
	$recurring .= "<tr id=\"Monthly\" style=\"display:none;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"monthlyinterval\" id=\"monthlyinterval\" size=\"3\" value=\"1\" /> months<br/>";
	$recurring .= "	<input type=\"radio\" name=\"monthlytype\" value=\"byweek\" /> The ";
	$recurring .= "		<select name=\"monthlyweeknum\">";
	$recurring .= "			<option value=\"1\">First</option>";
	$recurring .= "			<option value=\"2\">Second</option>";
	$recurring .= "			<option value=\"3\">Third</option>";
	$recurring .= "			<option value=\"4\">Fourth</option>";
	$recurring .= "			<option value=\"5\">Fifth</option>";
	$recurring .= "			<option value=\"-1\">Last</option>";
	$recurring .= "		</select>";
	$recurring .= "		<select name=\"monthlydayname\">";
	$recurring .= "			<option value=\"MO\">Monday</option>";
	$recurring .= "			<option value=\"TU\">Tuesday</option>";
	$recurring .= "			<option value=\"WE\">Wednesday</option>";
	$recurring .= "			<option value=\"TH\">Thursday</option>";
	$recurring .= "			<option value=\"FR\">Friday</option>";
	$recurring .= "			<option value=\"SA\">Satruday</option>";
	$recurring .= "			<option value=\"SU\">Sunday</option>";						
	$recurring .= "		</select>";
	$recurring .= "		<br />";
	$recurring .= "		<input type=\"radio\" name=\"monthlytype\" value=\"byday\" /> Recur on the <input type=\"text\" name=\"monthlyday\" id=\"monthlyday\" size=\"5\" /> day of the month ";
	$recurring .= "</td></tr>";
	
	$recurring .= "<tr id=\"Yearly\" style=\"display:none;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "		Every <input type=\"text\" name=\"yearlyinterval\" id=\"yearlyinterval\" size=\"3\" value=\"1\" /> years";
	$recurring .= "</td></tr>";

	$recurring .= "<tr id=\"recurring\" style=\"display:none;\"><td colspan=\"2\" style=\"padding-left:20px;\">";
	$recurring .= "	<br />";
	$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"none\" checked=\"checked\" />No end date<br />";
	$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"count\" />";
	$recurring .= "Create ";
	$recurring .= "<input type=\"text\" name=\"occurances\" id=\"occurances\" size=\"3\" /> appointment(s)<br />";

	$recurring .= "<input type=\"radio\" name=\"untilcount\" value=\"until\" />";
	$recurring .= "Repeat until ";
	$recurring .= "<input type=\"text\" name=\"until\" id=\"until\" size=\"10\" />";
	
	return $recurring;
}
?>
